
# include <iomanip>

void balance(Fl_Value_Slider* changed, int count, ...) {
    va_list all_other;
    double remainder = 1-changed->value();
    double divider = 0;
    int i;
    Fl_Value_Slider* current;

    va_start(all_other, count);
    for(i=0; i<count; i++) {
      divider += va_arg(all_other, Fl_Value_Slider*)->value();
    }
    va_end(all_other);
    va_start(all_other, count);
    if (divider <= 0) {
        for(i=0; i<count; i++) {
          va_arg(all_other, Fl_Value_Slider*)->value(remainder / count);
        }
    } else {
        for(i=0; i<count; i++) {
          current = va_arg(all_other, Fl_Value_Slider*);
          current->value(remainder*current->value() / divider);
        }
    }
    va_end(all_other);
    // now, because of rounding errors, the sum may not be exactly one
    // so make sure to call normalize() before actually using the parameters
}

void normalize(int count, ...) {
    va_list v;
    double sum = 0;
    int i;
    Fl_Value_Slider* current;

    // compute sum
    va_start(v, count);
    for(i=0; i<count; i++) {
      sum += va_arg(v, Fl_Value_Slider*)->value();
    }
    va_end(v);
//    if(sum != 1) {std::cout << "sum: " << std::setprecision(1000) << sum << "\n";}
    // normalize values
    va_start(v, count);
    for(i=0; i<count; i++) {
      current = va_arg(v, Fl_Value_Slider*);
      current->value(current->value() / sum);
    }
    va_end(v);
}
